function themeObj(){
	this.theme = 3;
	this.bgColors = new Array("#efe077", "#ffb4c8", "#b8e37a", "#cae4f5", 
							  "#46332f", "red",     "#ff00ff", "#402518", 
							  "#01c4de", "#7f7f7f", "#73ff73", "#666666");
	this.fgColors = new Array("#000000", "#000000", "#000000", "#000000", 
							  "#ffffff", "yellow",  "#ffffff", "#ffffff", 
							  "#0104de", "#000000", "#009700", "#cccccc");
}
themeObj.prototype.fg = function() {
	return this.fgColors[this.theme]
}
themeObj.prototype.bg = function() {
	return this.bgColors[this.theme]
}
themeObj.prototype.font = function() {
	//return this.bgColors[this.theme]
}
themeObj.prototype.set = function(i) {
	this.theme = i;
	winmgr.fillColors();
}
var theme = new themeObj();


function winmgrObj() {
	this.bgimage = null;
	this.viewID = 0;	
	this.views = new Array();
	this.dTimer = null;
	if (global.trial == false) {
		this.modes = new Array("Sequential", "Random", "Only the latest", "Latest 3", "Latest 5", "Stopped");
	} else {
		this.modes = new Array("Sequential", "Random", 
		"Only the latest <span style='font-size: small;'>(not in free lite)</span>", 
		"Latest 3 <span style='font-size: small;'>(not in free lite)</span>", 
		"Latest 5 <span style='font-size: small;'>(not in free lite)</span>", 
		"Stopped");
	}
	this.ttmodes = new Array("Animated icon", "No icon animation");
	this.aTimer = null;
	this.aseq = 0;

	// Must use obscure structure, ref. Google js obj method + event handler
	var that = this;
	window.onresize = (function(){that.resize()});
} 
winmgrObj.prototype.register = function(name, id) {
	this.views.push(document.getElementById(name));
	return this.views.length - 1;
}
winmgrObj.prototype.show = function(id){
	clearTimeout(this.dTimer);
	
	this.views[this.viewID].style.display = "none";
	this.views[id].style.display = "block";
	
	if (id != this.viewID) {
		this.viewID = id;
		/* 	WRT bugaa siten etta ikkkuna ei aina paivity
	 		menusta vaikka menun callback funktiota kutsutaan.
	 		Ilmeisesti menun poistuminen naytolta aiheuttaa redrawin
	 		ja WRT ei kasittele putkeen kahta redraw eventtia
	 		vaikka sisalto on muuttunut. Kaksois refresh timerilla
	 		auttaa bugiin. */
		this.dTimer = setTimeout("winmgr.show(" + id + ")", 500);
	}
}

winmgrObj.prototype.init = function() {
	//this.bgimage = document.getElementById("bgimage");
	this.modeButton = document.getElementById("modeButton");
	this.ttmodeButton = document.getElementById("ttmodeButton");
	this.demodeButton = document.getElementById("demodeButton");
	this.homeContent = document.getElementById("homeContent");
	this.homeDate = document.getElementById("homeDate");
	this.homeSender = document.getElementById("homeSender");
	this.homeIcon = document.getElementById("homeIcon");
	this.homeAnim = document.getElementById("homeAnim");
	//this.startButton = document.getElementById("startButton");
	this.scrollButton = document.getElementById("scrollButton");
	this.explSection = document.getElementById("explSection");
	//this.mainContent = document.getElementById("mainContent");
	//this.mainDate = document.getElementById("mainDate");
	//this.mainSender = document.getElementById("mainSender");
	//this.mainboxi = document.getElementById("mainboxi");
	this.fillThemeButts();
	//this.fillColors();
}
/*winmgrObj.prototype.setBGImage = function(src){
	this.bgimage.src = src;
}*/

winmgrObj.prototype.fillColors = function(){
	document.body.bgColor = theme.bg();
	document.body.text = theme.fg();
}

winmgrObj.prototype.fillThemeButts = function(){
	for(i = 0 ; i < 12 ; i++) {
		document.getElementById("themebutt" + i).style.backgroundColor = theme.bgColors[i];
		document.getElementById("themebutt" + i).style.color = theme.fgColors[i];
	}
	if (global.trial == true) {
		this.explSection.innerHTML = "Free lite version accesses only 5 oldest SMS messages"
	}
}

winmgrObj.prototype.updateContent = function(msg){
	this.updateHeader(msg.Sender, msg.Time);
	// TODO jos type == "MMS" && sms.body == "" print "MMS" as body 

	/*if (msg.BodyText.length <= 23)
		this.homeContent.style.fontSize = "33px";
	else if (msg.BodyText.length <= 35)
		this.homeContent.style.fontSize = "26px";
	else 
		this.homeContent.style.fontSize = "22px";
	*/
	this.updateBody(msg.BodyText);

	if (control.isRunning()) {
		if (control.scrollmode == 1) {
			scroller.show(msg.BodyText);
		} else {
			control.runtimer();
		}
	}
}

winmgrObj.prototype.updateContentImmediate = function(msg){
	this.updateHeader(msg.Sender, msg.Time);
	this.updateBody(msg.BodyText);
}

winmgrObj.prototype.updateHeader = function(sender, pvm){
	this.homeSender.innerHTML = sender;
	this.homeDate.innerHTML = pvm;
	//this.mainSender.innerHTML = sender;
	//this.mainDate.innerHTML = pvm;
}


winmgrObj.prototype.updateBody = function(txt){
	txt = txt.replace(/&/g,"&amp;");
	txt = txt.replace(/</g,"&#60;");
	txt = txt.replace(/>/g,"&#62;");
	this.homeContent.innerHTML = txt;
	//this.mainContent.innerHTML = txt;
}

winmgrObj.prototype.flushAnimate = function(){
	clearTimeout(this.aTimer);
	this.homeAnim.style.display = "none";
	this.homeContent.style.display = "block";
	control.runImmediate();
}
winmgrObj.prototype.animate = function(a) {
	//debugmgr.log("Anim " + a)
	clearTimeout(this.aTimer);
	if (a == -1) {
		this.homeAnim.style.display = "none";
		this.homeContent.style.display = "block";
		control.run2()
		return;
	} 
	if (a == 10) {
		this.homeContent.style.display = "none";
		this.homeContent.innerHTML = "";
		
		this.homeIcon.src = "images/bicon" + a + ".png";
		this.homeAnim.style.display = "block";
		//debugmgr.log("animate display block")
	} else {
		this.homeIcon.src = "images/bicon" + a + ".png";
	}
	if (a > 0) {	
		a = a - 1;
		this.aTimer = setTimeout("winmgr.animate(" + a + ")", 75);
	} else if (a == 0) { // pidempi viive
		a = a - 1;
		this.aTimer = setTimeout("winmgr.animate(" + a + ")", 300);
	}
	
}
/*
winmgrObj.prototype.changeImg = function(uold, unew) {
	var imag = document.getElementsByTagName('img');
	for(var i=0;i<imag.length;i++) {
		if(imag[i].getAttribute('src')== uold){
			imag[i].removeAttribute('height');
			imag[i].setAttribute('src',unew);
		}
	}
}*/

winmgrObj.prototype.modeText = function(m) {
	this.modeButton.innerHTML = this.modes[m];	
}
winmgrObj.prototype.ttmodeText = function(m) {
	this.ttmodeButton.innerHTML = this.ttmodes[m];	
}
winmgrObj.prototype.demodeText = function(d) {
	this.demodeButton.innerHTML = "Delay " + d + " s";	
}
winmgrObj.prototype.scrollText = function(d) {
	if (d == 0)
		this.scrollButton.innerHTML = "Show first lines";	
	else
		this.scrollButton.innerHTML = "Scroll text";

}
/*
winmgrObj.prototype.startText = function(d) {
	if (d == 1)
		this.startButton.innerHTML = "Running";	
	else
		this.startButton.innerHTML = "Stopped";
}*/
winmgrObj.prototype.w = function(x){
	return Math.floor(this.width*x / 100);
}
winmgrObj.prototype.h = function(x){
	return Math.floor(this.height*x / 100);
}
winmgrObj.prototype.resize = function() {
	this.width  = window.innerWidth;
	this.height = window.innerHeight;
	
	//this.bgimage.style.width = this.width + "px";			
	//this.bgimage.style.height = this.height + "px";
	
	if (this.height < ((screen.height * 3) / 4) || this.width < ((screen.width * 3) / 4)) {
		this.show(global.homeView);
		if (control.isRunning()) {
			control.stop();
			control.start();
		}
		// vaikuttaako paivitys ongelmaan
		// kokeiluja tahan
	} /*else if (!license.accepted) {
		this.show(global.licenseView);
		if (control.isRunning()) {
			control.stop();
			if (control.scrollmode == 1)
				scroller.flush()
		}
	} */ else if (this.viewID == global.homeView) {
		// Resizing from home to full screen
		if (control.isRunning()) {
			control.stop();
			if (control.scrollmode == 1)
				scroller.flush()
		}
		this.show(global.mainView1);
	}
	
	// Any layout coordinate calculations and settings here:

}


var winmgr = new winmgrObj();

//--------------------------------------------------------------------------------------------
function scrollerObj(){
	this.text = "";
	this.index = 0;
	this.dTimer = null;
}
scrollerObj.prototype.show = function(s) {
	clearTimeout(this.dTimer);
	this.text = s;	
	this.index = 0;
	if (this.text != "") {
		this.dTimer = setTimeout("scroller.print()", 1000 * control.delays[control.demode]);
	}
}
scrollerObj.prototype.flush = function(){
	clearTimeout(this.dTimer);
	winmgr.updateBody(this.text);	
}

scrollerObj.prototype.print = function() {	
	winmgr.updateBody(this.text.slice(this.index));
	if (this.index < this.text.length-1) {
		this.index = this.index + 1;
		this.dTimer = setTimeout("scroller.print()", 200);
	} else {
		control.run();
	}
}
scroller = new scrollerObj();
/*
function teletypeObj() {
	this.keypad = "-2cba-3fed-4ihg-5lkj-6onm-7srqp-9vut-9zyxw-2CBA-3FED-4IHG-5LKJ-6ONM-7SRQP-8VUT-9ZYXW-";
	this.text = "";
	this.interm = "";
	this.current = "-";
	this.dTimer = null;
}
teletypeObj.prototype.show = function(s) {
	clearTimeout(this.dTimer);
	this.text = s;
	this.interm = "";
	this.current = "-"
	if (this.text != "") {
		this.print();
	}
}
teletypeObj.prototype.flush = function(){
	clearTimeout(this.dTimer);
	winmgr.updateBody(this.text);	
}

teletypeObj.prototype.nextChar = function(current, target){
	if (target == "-") {
		return target;
	}
	var i = this.keypad.indexOf(target);
	if (i == -1) {
		return target;
	}
	j = this.keypad.indexOf(current, i);
	return this.keypad[j-1];
}

teletypeObj.prototype.print = function() {	
	target = this.text[this.interm.length];
	if (this.interm.length < this.text.length-1) {
		if (this.current == target) {
			this.interm = this.interm + target;
			target = this.text[this.interm.length];
			this.current = this.nextChar("-", target);
			this.dTimer = setTimeout("teletype.print()", rand(400));
		} else {
			this.current = this.nextChar(this.current, target);
			this.dTimer = setTimeout("teletype.print()", rand(200));
		}
	}
	winmgr.updateBody(this.interm + this.current);
}

var teletype = new teletypeObj();
*/
